#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <xs>
#include <engine>
#include <zombieplague>

#define CustomItem(%0) (pev(%0, pev_impulse) == WEAPON_KEY)

// CWeaponBox
#define m_rgpPlayerItems_CWeaponBox 34

// CBasePlayerItem
#define m_pPlayer 41
#define m_pNext 42
#define m_iId 43

// CBasePlayerWeapon
#define m_flNextPrimaryAttack 46
#define m_flNextSecondaryAttack 47
#define m_flTimeWeaponIdle 48
#define m_iPrimaryAmmoType 49
#define m_iClip 51
#define m_fInReload 54
#define m_fInSpecialReload 55
#define m_iShotsFired 64
#define m_fWeaponState 74

// CBaseMonster
#define m_flNextAttack 83

// CBasePlayer
#define m_rpgPlayerItems 367
#define m_pActiveItem 373
#define m_rgAmmo 376

#define WEAPON_KEY 4075
#define WEAPON_OLD "weapon_usp"
#define WEAPON_NEW "cs_adekvat/weapon_infinity_adekvat"

#define WEAPON_MODEL_V "models/cs_adekvat/weapons/v_infinity_fix_v2.mdl"
#define WEAPON_MODEL_P "models/cs_adekvat/weapons/p_dinfi.mdl"
#define WEAPON_MODEL_W "models/cs_adekvat/weapons/w_cso_weapons.mdl"
#define WEAPON_MODEL_S "models/pshell.mdl"
#define WEAPON_SOUND_S "weapons/infi-1.wav"
#define WEAPON_ANIM    "dualpistols"

new const sprites[][]= { "sprites/wall_puff1.spr" }

#define WEAPON_AMMO				120
#define WEAPON_DAMAGE			59.0
#define WEAPON_DAMAGE2			44.0
#define WEAPON_RATE				0.2
#define WEAPON_RATE2   			0.1
#define WEAPON_KNOCKBACK		35.0
#define WEAPON_VELOCITYMODIFER	0.35

#define WPNSTATE_ELITE_LEFT (1<<3)

/*https://wiki.alliedmods.net/CS_WeaponList_Message_Dump*/
#define LIST_OLD_1 6
#define LIST_OLD_2 100
#define LIST_OLD_3 -1
#define LIST_OLD_4 -1
#define LIST_OLD_5 1
#define LIST_OLD_6 4
#define LIST_OLD_7 16
#define LIST_OLD_8 0

#define LIST_NEW_1 6
#define LIST_NEW_2 get_pcvar_num(cvar_weapon_bpammo)
#define LIST_NEW_3 -1
#define LIST_NEW_4 -1
#define LIST_NEW_5 1
#define LIST_NEW_6 4
#define LIST_NEW_7 16
#define LIST_NEW_8 0

new g_AllocString_V, g_AllocString_P, g_AllocString_E, g_ModelIndexShell
new g_msg_WeaponList
new g_Mode[33], g_item, g_Infinity[33]

new cvar_weapon_ammo, cvar_weapon_bpammo, cvar_weapon_damage, cvar_weapon_damage2, cvar_weapon_speed, cvar_weapon_speed2, cvar_weapon_punchangle, 
cvar_weapon_punchangle2, cvar_weapon_ammo_cost, cvar_weapon_reloadtime, cvar_weapon_deploytime, cvar_weapon_submodel

public plugin_init() 
{
	RegisterHam(Ham_Item_Deploy, WEAPON_OLD, "fw_Item_Deploy_Post", 1);
	RegisterHam(Ham_Item_PostFrame, WEAPON_OLD, "fw_Item_PostFrame");
	RegisterHam(Ham_Item_AddToPlayer, WEAPON_OLD, "fw_Item_AddToPlayer_Post", 1);
	
	RegisterHam(Ham_Weapon_PrimaryAttack, WEAPON_OLD, "fw_Weapon_PrimaryAttack");
	RegisterHam(Ham_Weapon_Reload, WEAPON_OLD, "fw_Weapon_Reload");
	RegisterHam(Ham_Weapon_WeaponIdle, WEAPON_OLD, "fw_Weapon_WeaponIdle");
	RegisterHam(Ham_Weapon_SecondaryAttack, WEAPON_OLD, "fw_Weapon_SecondaryAttack");
	
	RegisterHam(Ham_TraceAttack, "func_breakable",     "fw_TraceAttack");
	RegisterHam(Ham_TraceAttack, "hostage_entity",     "fw_TraceAttack");
	RegisterHam(Ham_TraceAttack, "player",             "fw_TraceAttack");
	RegisterHam(Ham_TraceAttack, "info_target",        "fw_TraceAttack");
	
	cvar_weapon_ammo = register_cvar("infinity_ammo", "30")
	cvar_weapon_bpammo = register_cvar("infinity_bpammo", "120")
	cvar_weapon_damage = register_cvar("infinity_damage", "1.15")
	cvar_weapon_damage2 = register_cvar("infinity_damage_attack2", "1.10")
	cvar_weapon_speed = register_cvar("infinity_fire_speed", "0.15")
	cvar_weapon_speed2 = register_cvar("infinity_fire_speed_attack2", "0.1")
	cvar_weapon_punchangle = register_cvar("infinity_recoil", "0.9")
	cvar_weapon_punchangle2 = register_cvar("infinity_recoil_attack2", "0.75")
	cvar_weapon_ammo_cost  = register_cvar("infinity_ammo_cost", "280")
	cvar_weapon_reloadtime = register_cvar("infinity_reload_time", "4.03")
	cvar_weapon_deploytime = register_cvar("infinity_deploy_time", "1.2")
	cvar_weapon_submodel = register_cvar("infinity_submodel", "4")	
			
	register_forward(FM_UpdateClientData, "fw_UpdateClientData_Post", 1);
	register_forward(FM_PlaybackEvent, "fw_PlaybackEvent");
	register_forward(FM_SetModel, "fw_SetModel");
	
	g_msg_WeaponList = get_user_msgid("WeaponList");
	
	register_clcmd(WEAPON_NEW, "hook_weapon");
	g_item = zp_register_extra_item("Infinity", 20, ZP_TEAM_HUMAN);	
}

public plugin_precache() 
{
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_V);
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_P);
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_W);
	g_ModelIndexShell = engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_S);
	engfunc(EngFunc_PrecacheSound, WEAPON_SOUND_S);
	
	engfunc(EngFunc_PrecacheGeneric, "sprites/cs_adekvat/640hud39s.spr");
	
	new buffer[64]; formatex(buffer, charsmax(buffer), "sprites/%s.txt", WEAPON_NEW);
	engfunc(EngFunc_PrecacheGeneric, buffer);
	
	g_AllocString_V = engfunc(EngFunc_AllocString, WEAPON_MODEL_V);
	g_AllocString_P = engfunc(EngFunc_AllocString, WEAPON_MODEL_P);
	g_AllocString_E = engfunc(EngFunc_AllocString, WEAPON_OLD);
	
	for(new i = 0 ; i < sizeof(sprites) ; i++)
		precache_generic(sprites[i]) ;	
}

public plugin_natives()
{
	register_native("zp_weapon_infinity", "give_infinity", 1)
	register_native("GetInfinity", "GetInfinity", 1)
}

public zp_buy_ammo_2(id)
{
	new iEnt = get_pdata_cbase( id , 373 , 5 );
	
	if(!CustomItem(iEnt)) 
		return;	

	zp_set_ammo_value(id, get_pcvar_num(cvar_weapon_ammo))
	zp_set_ammo_cost(id, get_pcvar_num(cvar_weapon_ammo_cost))
	zp_set_ammo_max(id, get_pcvar_num(cvar_weapon_bpammo))
}

public GetInfinity(id)
{
	return g_Infinity[id];
}

public zp_user_humanized_post(id, attacker)  
{
	if(zp_get_user_hero(id))
	{
		give_infinity(id)
		g_Infinity[id] = true
		return
	}
}

public zp_round_ended() 
{ 
    for (new id = 1; id <= get_maxplayers(); id++) 
    { 
        if( !is_user_alive( id ) ) 
            continue 
         
        if(zp_get_user_hero(id)) 
        { 
        ham_strip_weapon(id, "weapon_usp")
        g_Infinity[id] = false
        }  
    } 
}

public zp_use_infected_pre(id, attacker)  
{
	if(zp_get_user_hero(id))
	{
		ham_strip_weapon(id, "weapon_usp")
		g_Infinity[id] = false
	}
}

stock ham_strip_weapon(id, weapon[])
{
	if(!equal(weapon,"weapon_usp",7)) 
		return 0
                
	new wId = get_weaponid(weapon)
                
	if(!wId) return 0
                
	new wEnt
                
	while((wEnt = find_ent_by_class(wEnt, weapon)) && entity_get_edict(wEnt, EV_ENT_owner) != id) {}
                
	if(!wEnt) return 0
                
	if(get_user_weapon(id) == wId) 
		ExecuteHamB(Ham_Weapon_RetireWeapon,wEnt);
                
	if(!ExecuteHamB(Ham_RemovePlayerItem,id,wEnt)) 
		return 0
                                
	ExecuteHamB(Ham_Item_Kill, wEnt)
                
	entity_set_int(id, EV_INT_weapons, entity_get_int(id, EV_INT_weapons) & ~(1<<wId))
	return 1
}

public hook_weapon(id) { engclient_cmd(id, WEAPON_OLD); return PLUGIN_HANDLED; }
public zp_extra_item_selected(id, item) if(item == g_item) give_infinity(id);

public give_infinity(id) 
{
	UTIL_DropWeapon(id, 2);
	
	static weapon, ammotype; 
	
	weapon = give_weapon(id);
	
	if(!weapon) 
		return;
			
	emit_sound(id, CHAN_ITEM, "items/gunpickup2.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	
	ammotype = m_rgAmmo + get_pdata_int(weapon, m_iPrimaryAmmoType, 4);
	
	if(get_pdata_int(id, ammotype, 5) < get_pcvar_num(cvar_weapon_bpammo)) 
		set_pdata_int(id, ammotype, get_pcvar_num(cvar_weapon_bpammo), 5);
}

public give_weapon(id) 
{
	static ent; 
	ent = engfunc(EngFunc_CreateNamedEntity, g_AllocString_E);
	
	if(ent <= 0) 
		return 0;
	
	set_pev(ent, pev_spawnflags, SF_NORESPAWN);
	set_pev(ent, pev_impulse, WEAPON_KEY);
	
	ExecuteHam(Ham_Spawn, ent);
	
	if(!ExecuteHamB(Ham_AddPlayerItem, id, ent)) 
	{
		engfunc(EngFunc_RemoveEntity, ent);
		return 0;
	}
	
	g_Mode[id] = 0
	g_Infinity[id] = true
	
	ExecuteHamB(Ham_Item_AttachToPlayer, ent, id);
	set_pdata_int(ent, m_iClip, get_pcvar_num(cvar_weapon_ammo), 4);
	return ent;
}

public fw_Item_Deploy_Post(ent) 
{
	if(!CustomItem(ent)) 
		return HAM_IGNORED;
		
	static id; 
	id = get_pdata_cbase(ent, m_pPlayer, 4);
	
	set_pev_string(id, pev_viewmodel2, g_AllocString_V);
	set_pev_string(id, pev_weaponmodel2, g_AllocString_P);
	
	set_pdata_float(id, m_flNextAttack, get_pcvar_float(cvar_weapon_deploytime), 5);
	set_pdata_float(ent, m_flTimeWeaponIdle, get_pcvar_float(cvar_weapon_deploytime), 4);
	
	set_pdata_int(ent, m_fInSpecialReload, 0, 4);
	
	set_pdata_string(id, 1968, WEAPON_ANIM, -1, 20);
	
	g_Mode[id] = 0
	
	UTIL_SendWeaponAnim(id, 13);
	
	return HAM_IGNORED;
}

public fw_TraceAttack(victim, attacker, Float:damage, Float:fDir[3]) <FireBullets: Enabled> 
{
	if(!is_user_alive(attacker)) 
		return HAM_IGNORED;
		
	static item; 
	item = get_pdata_cbase(attacker, 373, 5);
	
	if(item <= 0 || !CustomItem(item)) 
		return HAM_IGNORED;
		
	SetHamParamFloat(3, damage * (g_Mode[attacker] ? get_pcvar_float(cvar_weapon_damage2) : get_pcvar_float(cvar_weapon_damage)));
	return HAM_IGNORED;
}

public fw_TraceAttack() <FireBullets: Disabled> { return HAM_IGNORED; }
public fw_TraceAttack() <> { return FMRES_IGNORED; }

public fw_Item_PostFrame(ent) 
{
	if(!CustomItem(ent))
		return HAM_IGNORED;
		
	if(get_pdata_int(ent, m_fInReload, 4)) 
	{
		static id, clip, ammotype, ammo, j; 
		
		id = get_pdata_cbase(ent, m_pPlayer, 4);
		clip = get_pdata_int(ent, m_iClip, 4);
		ammotype = m_rgAmmo + get_pdata_int(ent, m_iPrimaryAmmoType, 4);
		ammo = get_pdata_int(id, ammotype, 5);
		j = min(get_pcvar_num(cvar_weapon_ammo) - clip, ammo);
		
		set_pdata_int(ent, m_iClip, clip+j, 4);
		set_pdata_int(id, ammotype, ammo-j, 5);
		set_pdata_int(ent, m_fInReload, 0, 4);
	}
	return HAM_IGNORED;
}

public fw_Item_AddToPlayer_Post(ent, id) 
{
	switch(pev(ent, pev_impulse)) 
	{
		case 0: Weaponlist(id, 0);
		case WEAPON_KEY: 
		{
			g_Infinity[id] = true
			Weaponlist(id, 1);
		}
	}
}

public fw_Weapon_PrimaryAttack(ent) 
{
	if(!CustomItem(ent)) 
		return HAM_IGNORED;
	
	if(get_pdata_int(ent, m_iShotsFired, 4)) 
		return HAM_SUPERCEDE;
		
	static clip, stage, id, flags; 
	
	clip = get_pdata_int(ent, m_iClip, 4);
	
	if(!clip) 
	{
		ExecuteHamB(Ham_Weapon_PlayEmptySound, ent);
		set_pdata_float(ent, m_flNextPrimaryAttack, 0.15, 4);
		set_pdata_float(ent, m_flNextSecondaryAttack, 0.15, 4);
		return HAM_SUPERCEDE;
	}
	
	static Float:user_punchangle[3];
	pev(id,pev_punchangle,user_punchangle)	
	
	state FireBullets: Enabled;
	ExecuteHam(Ham_Weapon_PrimaryAttack, ent);
	state FireBullets: Disabled;
	
	id = get_pdata_cbase(ent, m_pPlayer, 4);
	
	emit_sound(id, CHAN_WEAPON, WEAPON_SOUND_S, VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	
	set_pdata_float(ent, m_flNextPrimaryAttack, get_pcvar_float(cvar_weapon_speed), 4);
	set_pdata_float(ent, m_flNextSecondaryAttack, get_pcvar_float(cvar_weapon_speed)+0.5, 4);
	set_pdata_float(ent, m_flTimeWeaponIdle, 1.2, 4);
	
	stage = get_pdata_int(ent, m_fWeaponState, 4);
	flags = pev(id, pev_flags);
	
	static Float:user_newpunch[3];pev(id,pev_punchangle,user_newpunch)
	user_newpunch[0]=user_punchangle[0]+(user_newpunch[0]-user_punchangle[0])*get_pcvar_float(cvar_weapon_punchangle)
	user_newpunch[1]=user_punchangle[1]+(user_newpunch[1]-user_punchangle[1])*get_pcvar_float(cvar_weapon_punchangle)
	user_newpunch[2]=user_punchangle[2]+(user_newpunch[2]-user_punchangle[2])*get_pcvar_float(cvar_weapon_punchangle)
	set_pev(id,pev_punchangle,user_newpunch)	
	
	if(stage & WPNSTATE_ELITE_LEFT) 
	{
		stage &= ~WPNSTATE_ELITE_LEFT;
		if(clip > 2) 
		{
			UTIL_SendWeaponAnim(id, 2);
			set_pdata_int(ent, m_fInSpecialReload, 0, 4);
		}
		else 
		{
			switch(get_pdata_int(ent, m_fInSpecialReload, 4)) 
			{
				case 1: 
				{
					UTIL_SendWeaponAnim(id, 3);
					set_pdata_int(ent, m_fInSpecialReload, 2, 4);
				}
				default: 
				{
					UTIL_SendWeaponAnim(id, 3);
					set_pdata_int(ent, m_fInSpecialReload, 1, 4);
				}
			}
		}
		set_pev(id, pev_sequence, (flags & FL_DUCKING) ? 24 : 28);
		UTIL_EjectBrass(id, g_ModelIndexShell, -8.0, 8.0, 6.0, 10, 50);
	}
	else 
	{
		stage |= WPNSTATE_ELITE_LEFT;
		if(clip > 2) 
		{
		    UTIL_SendWeaponAnim(id, 4);
		    set_pdata_int(ent, m_fInSpecialReload, 0, 4);
		}
		else 
		{
			switch(get_pdata_int(ent, m_fInSpecialReload, 4)) 
			{
				case 1: 
				{
					UTIL_SendWeaponAnim(id, 5);
					set_pdata_int(ent, m_fInSpecialReload, 2, 4);
				}
				default: 
				{
					UTIL_SendWeaponAnim(id, 5);
					set_pdata_int(ent, m_fInSpecialReload, 1, 4);
				}
			}
		}
		set_pev(id, pev_sequence, (flags & FL_DUCKING) ? 23 : 27);
		UTIL_EjectBrass(id, g_ModelIndexShell, -8.0, 8.0, -7.0, -10, -50);
	}
	set_pdata_int(ent, m_fWeaponState, stage, 4);
	
	g_Mode[id] = 0
	MakeDecal(id)
	
	return HAM_SUPERCEDE;
}

public fw_Weapon_Reload(ent) 
{
	if(!CustomItem(ent)) 
		return HAM_IGNORED;
		
	static clip, id; 
	
	clip = get_pdata_int(ent, m_iClip, 4); 
	
	if(clip == get_pcvar_num(cvar_weapon_ammo)) 
		return HAM_SUPERCEDE;
	
	id = get_pdata_cbase(ent, m_pPlayer, 4);
	
	if(!get_pdata_int(id, m_rgAmmo + get_pdata_int(ent, m_iPrimaryAmmoType, 4), 5)) 
		return HAM_IGNORED;

	set_pdata_int(ent, m_iClip, 0, 4);
	
	ExecuteHam(Ham_Weapon_Reload, ent);
	
	set_pdata_int(ent, m_iClip, clip, 4);
	set_pdata_float(id, m_flNextAttack, get_pcvar_float(cvar_weapon_reloadtime), 5);
	set_pdata_float(ent, m_flTimeWeaponIdle, get_pcvar_float(cvar_weapon_reloadtime), 4);
	set_pdata_int(ent, m_fInReload, 1, 4);
	set_pdata_int(ent, m_fInSpecialReload, 0, 4);
	
	UTIL_SendWeaponAnim(id, 12);
	
	return HAM_SUPERCEDE;
}

public fw_Weapon_WeaponIdle(ent) 
{
	if(!CustomItem(ent) || get_pdata_float(ent, m_flTimeWeaponIdle, 4) > 0.0) return HAM_IGNORED;
	static id; id = get_pdata_cbase(ent, m_pPlayer, 4);
	UTIL_SendWeaponAnim(id, 0);
	set_pdata_float(ent, m_flTimeWeaponIdle, 5.0, 4);
	return HAM_SUPERCEDE;
}

public fw_Weapon_SecondaryAttack(ent) 
{
	if(!CustomItem(ent)) 
		return HAM_IGNORED;
		
	static clip, id, stage, flags 
	clip = get_pdata_int(ent, m_iClip, 4);
	if(!clip) 
	{
		ExecuteHamB(Ham_Weapon_PlayEmptySound, ent);
		set_pdata_float(ent, m_flNextPrimaryAttack, 0.15, 4);
		set_pdata_float(ent, m_flNextSecondaryAttack, 0.15, 4);
		return HAM_SUPERCEDE;
	}
	
	set_pdata_int(ent, m_iShotsFired, 0, 4);
	
	static Float:user_punchangle[3];
	pev(id,pev_punchangle,user_punchangle)	
	
	state FireBullets: Enabled;
	ExecuteHam(Ham_Weapon_PrimaryAttack, ent);
	state FireBullets: Disabled;
	
	id = get_pdata_cbase(ent, m_pPlayer, 4);
	
	emit_sound(id, CHAN_WEAPON, WEAPON_SOUND_S, VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	
	set_pdata_float(ent, m_flNextPrimaryAttack, get_pcvar_float(cvar_weapon_speed2)+0.5, 4);
	set_pdata_float(ent, m_flNextSecondaryAttack, clip == 1 ? 1.0 : get_pcvar_float(cvar_weapon_speed2), 4);
	set_pdata_float(ent, m_flTimeWeaponIdle, 1.2, 4);
	
	stage = get_pdata_int(ent, m_fWeaponState, 4);
	flags = pev(id, pev_flags);
			
	static Float:user_newpunch[3];pev(id,pev_punchangle,user_newpunch)
	user_newpunch[0]=user_punchangle[0]+(user_newpunch[0]-user_punchangle[0])*get_pcvar_float(cvar_weapon_punchangle2)
	user_newpunch[1]=user_punchangle[1]+(user_newpunch[1]-user_punchangle[1])*get_pcvar_float(cvar_weapon_punchangle2)
	user_newpunch[2]=user_punchangle[2]+(user_newpunch[2]-user_punchangle[2])*get_pcvar_float(cvar_weapon_punchangle2)
	set_pev(id,pev_punchangle,user_newpunch)			
			
	if(stage & WPNSTATE_ELITE_LEFT) 
	{
		stage &= ~WPNSTATE_ELITE_LEFT;
		if(clip > 2) 
		{
			UTIL_SendWeaponAnim(id, 6);
			set_pdata_int(ent, m_fInSpecialReload, 0, 4);
		}
		else 
		{
			switch(get_pdata_int(ent, m_fInSpecialReload, 4))
			{
				case 1: 
				{
					UTIL_SendWeaponAnim(id, 10);
					set_pdata_int(ent, m_fInSpecialReload, 2, 4);
				}
				default: 
				{
					UTIL_SendWeaponAnim(id, 10);
					set_pdata_int(ent, m_fInSpecialReload, 1, 4);
				}
			}
		}
		set_pev(id, pev_sequence, (flags & FL_DUCKING) ? 24 : 28);
		UTIL_EjectBrass(id, g_ModelIndexShell, -6.0, 11.0, 4.5, -10, -50);
	}
	else 
	{
		stage |= WPNSTATE_ELITE_LEFT;
		if(clip > 2) 
		{
			UTIL_SendWeaponAnim(id, 8);
			set_pdata_int(ent, m_fInSpecialReload, 0, 4);
		}
		else 
		{
			switch(get_pdata_int(ent, m_fInSpecialReload, 4)) 
			{
				case 1: 
				{
					UTIL_SendWeaponAnim(id, 11);
					set_pdata_int(ent, m_fInSpecialReload, 2, 4);
				}
				default: 
				{
					UTIL_SendWeaponAnim(id, 11);
					set_pdata_int(ent, m_fInSpecialReload, 1, 4);
				}
			}
		}
		set_pev(id, pev_sequence, (flags & FL_DUCKING) ? 23 : 27);
		UTIL_EjectBrass(id, g_ModelIndexShell, -6.0, 11.0, -5.0, 10, 50);
	}
	set_pdata_int(ent, m_fWeaponState, stage, 4);
	set_pev(id, pev_button, pev(id, pev_button) & ~IN_ATTACK);
	
	g_Mode[id] = 1	
	MakeDecal(id)
	
	return HAM_SUPERCEDE;
}

public fw_SetModel(ent) 
{
	if(!pev_valid(ent)) 
		return FMRES_IGNORED;
		
	static i, classname[32], item; pev(ent, pev_classname, classname, 31);
		
	if(!equal(classname, "weaponbox"))
		return FMRES_IGNORED;
		
	for(i = 0; i < 6; i++) 
	{
		item = get_pdata_cbase(ent, m_rgpPlayerItems_CWeaponBox + i, 4);
		if(item > 0 && CustomItem(item)) 
		{
			engfunc(EngFunc_SetModel, ent, WEAPON_MODEL_W);
			set_pev(ent, pev_body, get_pcvar_num(cvar_weapon_submodel))
			g_Infinity[pev(ent, pev_owner)] = false
			return FMRES_SUPERCEDE;
		}
	}
	return FMRES_IGNORED;
}

public fw_UpdateClientData_Post(id, SendWeapons, CD_Handle) 
{
	if(get_cd(CD_Handle, CD_DeadFlag) != DEAD_NO) 
		return;
		
	static item; 
	item = get_pdata_cbase(id, m_pActiveItem, 5);
	
	if(item <= 0 || !CustomItem(item)) 
		return;
		
	set_cd(CD_Handle, CD_flNextAttack, 999999.0);
}

public fw_PlaybackEvent() <FireBullets: Enabled> { return FMRES_SUPERCEDE; }
public fw_PlaybackEvent() <FireBullets: Disabled> { return FMRES_IGNORED; }
public fw_PlaybackEvent() <> { return FMRES_IGNORED; }

stock UTIL_SendWeaponAnim(id, Sequence) 
{
	set_pev(id, pev_weaponanim, Sequence);
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, _, id);
	write_byte(Sequence);
	write_byte(0);
	message_end();
}

stock UTIL_DropWeapon(id, slot) 
{
	static iEntity; 
	iEntity = get_pdata_cbase(id, (m_rpgPlayerItems + slot), 5);
	
	if(iEntity > 0) 
	{
		static iNext;
		static szWeaponName[32];
       
		do
		{
			iNext = get_pdata_cbase(iEntity, m_pNext, 4);
			if(get_weaponname(get_pdata_int(iEntity, m_iId, 4), szWeaponName, 31)) 
			{  
				engclient_cmd(id, "drop", szWeaponName);
			}
		} while(( iEntity = iNext) > 0);
	}
}

stock Weaponlist(id, type) 
{
	message_begin(MSG_ONE, g_msg_WeaponList, _, id);
	if(type) 
	{
		write_string(WEAPON_NEW);
	        write_byte(LIST_NEW_1);
	        write_byte(LIST_NEW_2);
	        write_byte(LIST_NEW_3);
	        write_byte(LIST_NEW_4);
	        write_byte(LIST_NEW_5);
	        write_byte(LIST_NEW_6);
	        write_byte(LIST_NEW_7);
	        write_byte(LIST_NEW_8);
	}
	else 
	{
		write_string(WEAPON_OLD);
	        write_byte(LIST_OLD_1);
	        write_byte(LIST_OLD_2);
	        write_byte(LIST_OLD_3);
	        write_byte(LIST_OLD_4);
	        write_byte(LIST_OLD_5);
	        write_byte(LIST_OLD_6);
	        write_byte(LIST_OLD_7);
	        write_byte(LIST_OLD_8);
	}
	message_end();
}

stock MakeDecal(id)
{
	new origin[3], target, body ;
	get_user_origin(id, origin, 3) ;
	get_user_aiming(id, target, body) ;
	
	if(is_user_alive(target))
		return ;
		
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) ;
	write_byte(TE_WORLDDECAL) ;
	write_coord(origin[0]) ;
	write_coord(origin[1]) ;
	write_coord(origin[2]) ;
	write_byte(41) ;
	message_end() ;
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) ;
	write_byte(TE_GUNSHOTDECAL) ;
	write_coord(origin[0]) ;
	write_coord(origin[1]) ;
	write_coord(origin[2]) ;
	write_short(id) ;
	write_byte(41) ;
	message_end() ;

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) ;
	write_byte(TE_STREAK_SPLASH)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_coord(random_num(-20, 20))
	write_coord(random_num(-20, 20))
	write_coord(random_num(-20, 20)) 
	write_byte(4)
	write_short(30)
	write_short(3)
	write_short(75)
	message_end() ;
}

stock UTIL_EjectBrass(id, ModelShellIndex, Float:Up, Float:Forward, Float:Right, Koord1, Koord2) 
{
	static Float:Velocity[3]; pev(id, pev_velocity, Velocity);
	static Float:ViewOfs[3]; pev(id, pev_view_ofs, ViewOfs);
	static Float:Angles[3]; pev(id, pev_angles, Angles);
	static Float:Origin[3]; pev(id, pev_origin, Origin);
	static Float:AnglesV[3]; pev(id, pev_v_angle, AnglesV);
	static Float:Punchangle[3]; pev(id, pev_punchangle, Punchangle);
	
	AnglesV[0] = Punchangle[0] + AnglesV[0];
	AnglesV[1] = Punchangle[1] + AnglesV[1];
	AnglesV[2] = Punchangle[2] + AnglesV[2];
	
	engfunc(EngFunc_MakeVectors, AnglesV);
	
	static Float:VRight[3]; global_get(glb_v_right, VRight);
	static Float:VUp[3]; global_get(glb_v_up, VUp);
	static Float:VForward[3]; global_get(glb_v_forward, VForward);
	static Float:vShellOrigin[3], Float:vShellVelocity[3];

	vShellOrigin[0] = Origin[0]+ViewOfs[0]+VUp[0]*Up+VForward[0]*Forward+VRight[0]*Right;
	vShellOrigin[1] = Origin[1]+ViewOfs[1]+VUp[1]*Up+VForward[1]*Forward+VRight[1]*Right;
	vShellOrigin[2] = Origin[2]+ViewOfs[2]+VUp[2]*Up+VForward[2]*Forward+VRight[2]*Right;
	vShellVelocity[1] = Velocity[1]+VRight[1]*random_num(Koord1,Koord2)+VUp[1]*random_float(100.0,150.0)+VForward[1]*25.0;
	vShellVelocity[0] = Velocity[0]+VRight[0]*random_num(Koord1,Koord2)+VUp[0]*random_float(100.0,150.0)+VForward[0]*25.0;
	vShellVelocity[2] = Velocity[2]+VRight[2]*random_num(Koord1,Koord2)+VUp[2]*random_float(100.0,150.0)+VForward[2]*25.0;

	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, vShellOrigin, 0);
	write_byte(TE_MODEL);
	engfunc(EngFunc_WriteCoord, vShellOrigin[0]);
	engfunc(EngFunc_WriteCoord, vShellOrigin[1]);
	engfunc(EngFunc_WriteCoord, vShellOrigin[2]);
	engfunc(EngFunc_WriteCoord, vShellVelocity[0]);
	engfunc(EngFunc_WriteCoord, vShellVelocity[1]);
	engfunc(EngFunc_WriteCoord, vShellVelocity[2]);
	engfunc(EngFunc_WriteAngle, Angles[1]);
	write_short(ModelShellIndex);
	write_byte(1);
	write_byte(15); // 2.5 seconds
	message_end();
}